#ifndef DIALOGHV_H
#define DIALOGHV_H

#include <iostream>
#include <fstream>
#include <string>

// ROOT:
#include <TApplication.h>
#include <RQ_OBJECT.h>
#include <TGFrame.h>
#include <TGStatusBar.h>
#include <TGLabel.h>
#include <TGComboBox.h>
#include <TGNumberEntry.h>
#include <TGButton.h>
#include <TGButtonGroup.h>
#include <TTimer.h>
#include <TGLayout.h>
#include <TGTableLayout.h>

using namespace std;

class HVManager : public TGMainFrame {

public:
	HVManager(const TGWindow *p, UInt_t w, UInt_t h);
	~HVManager();
	void 							Exit();
	void 							Connects();
private:
	TGStatusBar					*statusbar;
	TGTextButton				*textbt_connect, *textbt_refresh;
	TGComboBox					*combobox_cardtype, *combobox_conntype, *combobox_pollmode;
	TGNumberEntry				*numentry_connlink, *numentry_connnode;
	TGNumberEntryField		*numentry_connaddr;
	int							flag_auto_update, flag_exit, flag_connected;
	TGGroupFrame				*tggroup_channels;
	TGTableLayout				*tlay_channels;
	void							InitGUI();
	void							UpdateGUI();
	void							AddLabels();
	void							RemoveLabels();
	void 							Welcome();
	ClassDef(HVManager,0);
};


#endif

